<template>
  <el-container class="home-container">
    <!-- 头部 -->
    <el-header>
      <div>
        <img src="@/assets/img/logo1.png" alt="" />
        <span>电商后台管理</span>
      </div>
      <el-button type="info" @click="logout">退出</el-button>
    </el-header>

    <!-- 页面主题 -->
    <el-container>
      <!-- 左侧 -->
      <!--动态绑定width  -->
      <el-aside :width="isCollapse ? '64px' : '200px'">
        <div class="toggle-button" @click="toggle">|||</div>
        <!-- 侧边导航 -->
        <el-menu
          background-color="#333744"
          text-color="#fff"
          active-text-color="#409EFF"
          unique-opened
          :collapse="isCollapse"
          :collapse-transition="false"
          router
          :default-active="activePath"
        >
          <!-- 一级菜单 -->
          <el-submenu
            :index="item.id + ''"
            v-for="item in menuList"
            :key="item.id"
          >
            <!-- 一级菜单模板 -->
            <template slot="title">
              <!-- i是图标 -->
              <i :class="iconList[item.id]"></i>
              <!-- span是文本 -->
              <span>{{ item.authName }}</span>
            </template>
            <!-- 二级菜单 -->
            <el-menu-item
              :index="'/' + secondMenu.path"
              v-for="secondMenu in item.children"
              :key="secondMenu.id"
              @click="saveNav('/' + secondMenu.path)"
            >
              <template slot="title">
                <!-- i是图标 -->
                <i class="el-icon-menu"></i>
                <!-- span是文本 -->
                <span>{{ secondMenu.authName }}</span>
              </template>
            </el-menu-item>
          </el-submenu>
        </el-menu>
      </el-aside>
      <!-- 右侧主体 -->
      <el-main>
        <!-- 路由占位符 -->
        <router-view></router-view>
      </el-main>
    </el-container>
  </el-container>
</template>

<script>
export default {
  created() {
    this.getMenuList();
    this.activePath = window.sessionStorage.getItem("activePath");
  },
  data() {
    return {
      // 左侧菜单数据
      menuList: [],
      iconList: {
        125: "el-icon-user",
        103: "el-icon-coin",
        101: "el-icon-shopping-cart-full",
        102: "el-icon-sell",
        145: "el-icon-pie-chart",
      },
      isCollapse: false,
      activePath: "",
    };
  },
  methods: {
    logout() {
      // 清空sessionStorage保存的token
      window.sessionStorage.clear();
      // 编程时导航返回login页面
      this.$router.push("/login");
    },
    // 获取所有菜单
    async getMenuList() {
      const { data: res } = await this.$http.get("menus");
      // console.log(res);
      if (res.meta.status !== 200) return this.$message.error(res.meta.msg);
      this.menuList = res.data;
    },
    // 菜单折叠和展开
    toggle() {
      this.isCollapse = !this.isCollapse;
    },
    //保存链接的激活状态
    saveNav(activePath) {
      window.sessionStorage.setItem("activePath", activePath);
      this.activePath = activePath;
    },
  },
};
</script>

<style" scoped>
.home-container {
  height: 100%;
}
.el-header {
  background-color: #373d41;
  display: flex;
  justify-content: space-between;
  padding-left: 0;
  align-items: center;
  color: #fff;
  font-size: 20px;
}

.el-header div {
  display: flex;
  align-items: center;
}
.el-header div span {
  margin-left: 30px;
}
.el-header img {
  width: 15%;
  height: 15%;
}
.el-aside {
  background-color: #333744;
  
}
.el-menu {
    border-right: solid 0px #e6e6e6;
  }
.el-main {
  background-color: #eaedf1;
}
.toggle-button {
  background-color: #4a5064;
  color: white;
  line-height: 24px;
  text-align: center;
  letter-spacing: 0.2rem;
  cursor: pointer;
}
</style>>